System got froze after resume from screen off

Bug #1216781 reported by Sean Zhang on 2013-08-26
18
This bug affects 1 person
Affects Status Importance Assigned to Milestone
OEM Priority Project
Critical
Ara Pulido
Precise
Critical
Unassigned
compiz (Ubuntu)
Undecided
Unassigned
Precise
Undecided
Timo Jyrinki

Bug Description

[Impact]

System gets frozen occassionally.

[Test Case]

See below.

[Regression Potential]

The update reverts the patch to the state it was before previous upload. The regression is that performance regresses back to the 5-10% lower level it was before, for Intel / Nouveau using Mesa <= 9.0.x.

---

STEPS:
1. Login system
2. Navigate to 'System Setting' → 'Brightness and Lock'
3. Set 'Turn screen off when inactive for:' as '1 minute'
4. Set 'Lock' as 'ON' and set 'lock screen after : '3 minutes'
5. Check 'Require my password when waking from suspend'
6. Close 'Brightness and Lock' window.
7. Wait system go to screen off.
8. Waiting about 5 minute then active system.

Expect result:
Unlock interface display.

Actual result:
System got froze after resume from screen off. Cursor can move but right click and left click do not work.

Reproduce rate: 40%

Image: Ubuntu 12.04.2 LTS

Related branches

Sean Zhang (sean.zhang) wrote :

Bin Li (binli) found the root cause, it's related to compiz, after upgrade compzi to 1:0.9.7.12-0ubuntu2, it will met this issue.
And it's one potential issue when made the better performance for compiz.

+ * Performance note: unredirectable.evaluate is SLOW because it
+ * involves regex matching. Too slow to do on every window for
+ * every frame. So we only call it if a window is redirected AND
+ * potentially needs unredirecting. This means changes to
+ * unredirect_match while a window is unredirected already may not
+ * take effect until it is un-fullscreened again. But that's better
+ * than the high price of regex matching on every frame.

And for more information please view below related bugs.

blacklist_precise_mesa80_intel_nouveau.patch (bug#1167321)
fix_1095001.patch (bug#1095001)

This bug is requesting to change the patch mentioned above to fix the issue in bug description.

Bin Li (binli) wrote :

After we dig more, found the root cause isn't the fix_1095001.patch which in #1. It's another patch in the same commit.

The blacklist_precise_mesa80_intel_nouveau.patch allow 9.0.x Mesa, if I edit the /usr/share/compiz/opengl.xml, and remove the '$', the issue disappeared, for more information please view bug 1095001.

Bin Li (binli) wrote :

Sorry for wrong bug number in #2.

bug 1167321

Joey Zheng (jzheng) on 2013-08-27
Changed in oem-priority:
importance: Undecided → Critical
Yu Ning (yuningdodo) wrote :

we can set the blacklist with gconf: /apps/compiz-1/plugins/opengl/screen0/options/unredirect_river_blacklist

Ara Pulido (ara) on 2013-08-27
Changed in oem-priority:
assignee: nobody → Ara Pulido (apulido)
status: New → In Progress
Bin Li (binli) wrote :

After work with Ning and Shuoduo, I found the root cause is that blacklist_precise_mesa80_intel_nouveau.patch (bug 1167321).
Not the fix_1095001.patch (bug#1095001) which in comment#15.

blacklist_precise_mesa80_intel_nouveau.patch
===============================================================
 This patch sets the correct 12.04 LTS (precise) specific blacklist
 string for not enabling unredirection speedup on older Mesa versions
 when using Intel or Nouveau. It has evolved a bit.
 .
 Firstly it was just a cherry-pick to remove double backslashes which
 turned out not to work well from XML -> regexp engine.
 .
 Secondly "9.0" was added because an user reported that Mesa 9.0 from
 x-updates PPA wasn't enough on Intel. The full 12.04.2 stack however is
 good.
 .
 Thirdly as continuation from above, the string was modified so that
 9.0 (sharp) is still blacklisted, but 9.0.x (now in 12.04.2 LTS stack)
 is not anymore. This takes care of the remaining PPA users while allowing
 proper new stack users to have full gaming speed on Intel and Nouveau.

--- a/plugins/opengl/opengl.xml.in 2012-12-12 07:24:34 +0000
+++ b/plugins/opengl/opengl.xml.in 2012-12-17 10:39:15 +0000
@@ -46,7 +46,7 @@
        <option name="unredirect_driver_blacklist" type="string">
        <_short>Unredirect Driver Blacklist</_short>
        <_long>If non-empty, specifies a POSIX (extended) regular expression to match against the OpenGL driver strings (newline separated): "GL_VENDOR\nGL_RENDERER\nGL_VERSION". If the regular expression matches a substring of that concatenation then no windows will ever be unredirected while using that particular graphics driver.</_long>
- <default>(nouveau|Intel).*Mesa 8\\.0</default>
+ <default>(nouveau|Intel).*Mesa (8.0|9.0$)</default>
        </option>
    </options>
     </plugin>
===============================================================
The previous version is (nouveau|Intel).*Mesa (8.0|9.0) in default.

When we edit the /usr/share/compiz/opengl.xml, and remove the '$', it will fix this issue.

Joey Zheng (jzheng) on 2013-08-27
tags: added: regression-update
tags: added: regression-release
Ara Pulido (ara) wrote :

Timo confirmed that he is going to prepare a branch

Changed in compiz (Ubuntu):
assignee: nobody → Timo Jyrinki (timo-jyrinki)
Timo Jyrinki (timo-jyrinki) wrote :

The merge request is now at https://code.launchpad.net/~timo-jyrinki/compiz/disable_unredirection_mesa90x_again/+merge/182362 - you'll need a core-dev to sponsor that branch into SRU upload to precise.

A test build is built at ppa:unity-team/sru (https://launchpad.net/~unity-team/+archive/sru/+packages?field.name_filter=&field.status_filter=published&field.series_filter=precise).

I'm not a Compiz developer as such, so I cannot evaluate whether it would be possible to fix the issue without disabling the unredirection feature again for Intel/Nouveau users running Mesa 9.0.x. Daniel van Vugt is the developer behind the blacklisting feature and the backports of the fullscreen unredirection to precise.

Changed in compiz (Ubuntu Precise):
assignee: nobody → Timo Jyrinki (timo-jyrinki)
Changed in compiz (Ubuntu):
assignee: Timo Jyrinki (timo-jyrinki) → nobody
Changed in compiz (Ubuntu Precise):
status: New → In Progress
Changed in compiz (Ubuntu):
status: New → Invalid
description: updated
Ara Pulido (ara) wrote :

Hello Sean, or anyone else affected,

Accepted compiz into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/compiz/1:0.9.7.12-0ubuntu3 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in compiz (Ubuntu Precise):
status: In Progress → Fix Committed
tags: added: verification-needed
Doug McMahon (mc3man) on 2013-10-01
tags: added: verification-failed
removed: verification-needed
Doug McMahon (mc3man) wrote :

verification-failed
Reasons -
Does not actually fix the bug

Introduces a performance regression that will affect far more users that the so called 'fix'
(- 1 user listed as affected, no dupes. Even the reporter stated only occurs 40% of the time.
I tried 6 times, bug never occurred.

The few affected users can edit a .xml to workaround the issue themselves if they wish

Ara Pulido (ara) wrote :

Marking again as verification-needed as the verification needs to be done by someone actually affected by the bug.

Thanks

tags: added: verification-done
removed: verification-failed
tags: added: verification-needed
removed: verification-done
Changed in compiz (Ubuntu Precise):
status: Fix Committed → Incomplete
Bin Li (binli) wrote :

 I just upgrade the package from precise-propose, and verified it, it works fine for use. And I also compared the used memory and cpu, it looks same.

Brian Murray (brian-murray) wrote :

@Doug - can you provide some more information regarding this performance regression which you mention in comment #10?

On 10/8/2013 10:49 AM, Brian Murray wrote:
> @Doug - can you provide some more information regarding this performance
> regression which you mention in comment #10?
>
Brian - I'd point you to the review comments for this commit but can't
locate them anymore, maybe they're removed after approval?
This bug description does state the performance regression, for a more
relevant opinion you should ask vanvugt , who made an interesting
comment even though he did approve.

The other interesting comment, to paraphrase was - 'Well we don't have
the resources to actually fix the bug, so we'll just revert..'
Now if the current trend, when there is no one or time to fix, is to
revert a commit to 'fix', then I guess that's fine though this bug
doesn't seem to qualify there..

(In the same vein I could point you to 2 current compiz bugs in 13.10
that will affect a fair number of users *all* the time, will likely not
not be fixed due to no resources available & also could be 'fixed' with
a commit revert (to gtk3
Should I be pushing for a revert there?

Bin Li (binli) on 2013-10-15
tags: added: verification-done
removed: verification-needed
Bin Li (binli) wrote :

Sorry for not update the tag after #12.

Ara Pulido (ara) on 2013-10-16
Changed in compiz (Ubuntu Precise):
status: Incomplete → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package compiz - 1:0.9.7.12-0ubuntu3

---------------
compiz (1:0.9.7.12-0ubuntu3) precise; urgency=low

  * debian/patches/blacklist_precise_mesa80_intel_nouveau.patch:
    - Revert to blacklisting also 9.0.x (LP: #1216781)
 -- Timo Jyrinki <email address hidden> Tue, 27 Aug 2013 13:50:36 +0300

Changed in compiz (Ubuntu Precise):
status: Fix Committed → Fix Released

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

Ara Pulido (ara) on 2013-11-14
Changed in oem-priority:
status: In Progress → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers